// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Matrix.pas' rev: 5.00

#ifndef MatrixHPP
#define MatrixHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <SysUtils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Vector.hpp>	// Pascal unit
#include <Math1.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Matrix
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS ESDLMatrixError;
class PASCALIMPLEMENTATION ESDLMatrixError : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	#pragma option push -w-inl
	/* Exception.Create */ inline __fastcall ESDLMatrixError(const AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall ESDLMatrixError(const AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall ESDLMatrixError(int Ident)/* overload */ : Sysutils::Exception(
		Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall ESDLMatrixError(int Ident, const System::TVarRec * Args
		, const int Args_Size)/* overload */ : Sysutils::Exception(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall ESDLMatrixError(const AnsiString Msg, int AHelpContext
		) : Sysutils::Exception(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall ESDLMatrixError(const AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall ESDLMatrixError(int Ident, int AHelpContext)/* overload */
		 : Sysutils::Exception(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall ESDLMatrixError(System::PResStringRec ResStringRec
		, const System::TVarRec * Args, const int Args_Size, int AHelpContext)/* overload */ : Sysutils::Exception(
		ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~ESDLMatrixError(void) { }
	#pragma option pop
	
};


#pragma option push -b-
enum TDistMode { dmJaccard, dmManhattan, dmEuclid, dmEuclidSqr };
#pragma option pop

class DELPHICLASS TMatrix;
class PASCALIMPLEMENTATION TMatrix : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	int FNCol;
	int FNRow;
	void *Mat;
	int FPrecis[2];
	Classes::TNotifyEvent FOnChange;
	Math1::TSortExchgEvent FOnSortExchange;
	double __fastcall GetVal(int Nc, int Nr);
	void __fastcall SetVal(int Nc, int Nr, double Value);
	int __fastcall GetFPrecis(int ix);
	void __fastcall SetFPrecis(int ix, int value);
	
protected:
	void __fastcall SortExchange(Byte ExchgWhat, int index1, int index2, int first, int last);
	
public:
	__fastcall TMatrix(int Nc, int Nr);
	__fastcall virtual ~TMatrix(void);
	__property double Elem[int ix][int iy] = {read=GetVal, write=SetVal/*, default*/};
	bool __fastcall Add(TMatrix* MatB);
	int __fastcall CalcDistMat(TDistMode Mode, TMatrix* DMat);
	void __fastcall Changed(void);
	void __fastcall CopyColToVec(Vector::TVector* DestVec, int Col, int FirstRow, int LastRow);
	void __fastcall CopyFrom(TMatrix* MatSource, int SourceColLo, int SourceRowLo, int SourceColHi, int 
		SourceRowHi, int DestCol, int DestRow);
	void __fastcall Clone(TMatrix* MatSource);
	void __fastcall CopyFromVec(Vector::TVector* VecSource, int Source1stElem, int SourceLastElem, int 
		DestCol, int DestRow);
	void __fastcall CopyRowToVec(Vector::TVector* DestVec, int Row, int FirstCol, int LastCol);
	double __fastcall Determinant(void);
	void __fastcall Fill(double value);
	HIDESBASE void __fastcall Free(void);
	bool __fastcall Histogram(int LoX, int LoY, int HiX, int HiY, double FirstBin, double LastBin, double 
		BinWidth, Vector::TIntVector* Histo, int &Underflow, int &Overflow, int &MaxCnt);
	bool __fastcall Invert(void);
	bool __fastcall LoadFromFile(AnsiString FileName, bool AdjustMatrixSize);
	bool __fastcall LoadFromStream(Classes::TMemoryStream* InStream, bool AdjustMatrixSize);
	bool __fastcall LUdecomposition(TMatrix* &MatL, TMatrix* &MatU);
	__property int NrOfColumns = {read=FNCol, nodefault};
	__property int NrOfRows = {read=FNRow, nodefault};
	__property int Precision[int Index] = {read=GetFPrecis, write=SetFPrecis};
	void __fastcall MeanVar(int LowCol, int LowRow, int HighCol, int HighRow, double &Mean, double &Variance
		);
	void __fastcall MinMax(int LowCol, int LowRow, int HighCol, int HighRow, double &Minimum, double &Maximum
		);
	bool __fastcall Multiply(TMatrix* MatB, TMatrix* MatRes);
	bool __fastcall Quartiles(int LowCol, int LowRow, int HighCol, int HighRow, double &Q1, double &Q2, 
		double &Q3);
	bool __fastcall Resize(int Nc, int Nr);
	void __fastcall SaveToStream(Classes::TMemoryStream* &OutStream, int LoC, int LoR, int HiC, int HiR
		);
	void __fastcall SkewKurt(int LowCol, int LowRow, int HighCol, int HighRow, double &Skewness, double 
		&Kurtosis);
	void __fastcall SMult(double Scalar);
	void __fastcall SortCols(int SortRowIx, bool Ascending, int LowCol, int LowRow, int HighCol, int HighRow
		);
	void __fastcall SortRows(int SortColIx, bool Ascending, int LowCol, int LowRow, int HighCol, int HighRow
		);
	void __fastcall StandardizeColumns(Vector::TVector* Means, Vector::TVector* StdDevs);
	void __fastcall StandardizeRows(Vector::TVector* Means, Vector::TVector* StdDevs);
	bool __fastcall StoreOnFile(int LoC, int LoR, int HiC, int HiR, AnsiString FileName);
	bool __fastcall Subtract(TMatrix* MatB);
	double __fastcall Sum(int LoC, int LoR, int HiC, int HiR);
	bool __fastcall Transpose(void);
	double __fastcall Trace(void);
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property Math1::TSortExchgEvent OnSortExchange = {read=FOnSortExchange, write=FOnSortExchange};
};


class DELPHICLASS TIntMatrix;
class PASCALIMPLEMENTATION TIntMatrix : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	int FNCol;
	int FNRow;
	bool FIsSparse;
	int FNumAllocated;
	int FAllocBy;
	int FSparseNumElem;
	int FSparseLowCol;
	int FSparseHighCol;
	int FSparseLowRow;
	int FSparseHighRow;
	void *SpMat;
	void *Mat;
	Classes::TNotifyEvent FOnChange;
	Math1::TSortExchgEvent FOnSortExchange;
	int __fastcall GetVal(int Nc, int Nr);
	void __fastcall SetVal(int Nc, int Nr, int Value);
	
protected:
	void __fastcall SortExchange(Byte ExchgWhat, int index1, int index2, int first, int last);
	
public:
	__fastcall TIntMatrix(int Nc, int Nr);
	__fastcall TIntMatrix(int AllocBy);
	__fastcall virtual ~TIntMatrix(void);
	__property int Elem[int ix][int iy] = {read=GetVal, write=SetVal/*, default*/};
	bool __fastcall Add(TIntMatrix* MatB);
	void __fastcall ArrayToSparse(int AllocBy);
	void __fastcall Changed(void);
	void __fastcall Clone(TIntMatrix* MatSource);
	void __fastcall CopyColToVec(Vector::TIntVector* DestVec, int Col, int FirstRow, int LastRow);
	void __fastcall CopyFrom(TIntMatrix* MatSource, int SourceColLo, int SourceRowLo, int SourceColHi, 
		int SourceRowHi, int DestCol, int DestRow);
	void __fastcall CopyRowToVec(Vector::TIntVector* DestVec, int Row, int FirstCol, int LastCol);
	void __fastcall Fill(int value);
	bool __fastcall LoadFromFile(AnsiString FileName, bool AdjustMatrixSize);
	bool __fastcall LoadFromStream(Classes::TMemoryStream* InStream, bool AdjustMatrixSize);
	bool __fastcall LoadSparseMat(AnsiString FileName);
	__property int NrOfColumns = {read=FNCol, nodefault};
	__property int NrOfRows = {read=FNRow, nodefault};
	void __fastcall MeanVar(int LowCol, int LowRow, int HighCol, int HighRow, double &Mean, double &Variance
		);
	void __fastcall MinMax(int LowCol, int LowRow, int HighCol, int HighRow, int &Minimum, int &Maximum
		);
	bool __fastcall Multiply(TIntMatrix* MatB, TIntMatrix* MatRes);
	bool __fastcall Quartiles(int LowCol, int LowRow, int HighCol, int HighRow, double &Q1, double &Q2, 
		double &Q3);
	bool __fastcall Resize(int Nc, int Nr);
	void __fastcall SaveToStream(Classes::TMemoryStream* &OutStream, int LoC, int LoR, int HiC, int HiR
		);
	void __fastcall SkewKurt(int LowCol, int LowRow, int HighCol, int HighRow, double &Skewness, double 
		&Kurtosis);
	void __fastcall SMult(int Scalar);
	void __fastcall SortCols(int SortRowIx, bool Ascending, int LowCol, int LowRow, int HighCol, int HighRow
		);
	void __fastcall SortRows(int SortColIx, bool Ascending, int LowCol, int LowRow, int HighCol, int HighRow
		);
	void __fastcall SparseToArray(void);
	bool __fastcall StoreOnFile(int LoC, int LoR, int HiC, int HiR, AnsiString FileName);
	bool __fastcall StoreSparseMat(AnsiString FileName);
	bool __fastcall Subtract(TIntMatrix* MatB);
	int __fastcall Sum(int LoC, int LoR, int HiC, int HiR);
	int __fastcall Trace(void);
	bool __fastcall Transpose(void);
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property Math1::TSortExchgEvent OnSortExchange = {read=FOnSortExchange, write=FOnSortExchange};
};


class DELPHICLASS TMat3D;
class PASCALIMPLEMENTATION TMat3D : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	int FNumX;
	int FNumY;
	int FNumZ;
	void *Mat;
	Classes::TNotifyEvent FOnChange;
	double __fastcall GetVal(int Nx, int Ny, int Nz);
	void __fastcall SetVal(int Nx, int Ny, int Nz, double Value);
	
public:
	__fastcall TMat3D(int Nc, int Nr, int Nl);
	__fastcall virtual ~TMat3D(void);
	void __fastcall Changed(void);
	__property double Elem[int ix][int iy][int iz] = {read=GetVal, write=SetVal/*, default*/};
	void __fastcall Fill(double value);
	__property int NrOfColumns = {read=FNumX, nodefault};
	__property int NrOfRows = {read=FNumY, nodefault};
	__property int NrOfLayers = {read=FNumZ, nodefault};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	bool __fastcall Resize(int Nc, int Nr, int Nl);
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Matrix */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Matrix;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Matrix
