// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Rot3D.pas' rev: 5.00

#ifndef Rot3DHPP
#define Rot3DHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <ExtCtrls.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Menus.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Rot3d
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TColorScheme { csBWG, csSystem };
#pragma option pop

typedef SmallString<25>  TAxName;

#pragma option push -b-
enum TFrameStyle { fsNone, fsSimple, fsLowered, fsRaised, fsEmbossed, fsEngraved };
#pragma option pop

#pragma option push -b-
enum ItemType { tkNone, tkMarkAt, tkLineto, tkLine, tkMoveto, tkEverything };
#pragma option pop

#pragma option push -b-
enum TBoundingBox { bbNone, bbFrame, bbFaces };
#pragma option pop

struct TDrawCan;
typedef TDrawCan *PDrawCan;

struct TDrawCan
{
	TDrawCan *Next;
	double x;
	double y;
	double z;
	Graphics::TColor color;
	int tag;
	ItemType Element;
	union
	{
		struct 
		{
			Byte mark;
			
		};
		struct 
		{
			double x2;
			double y2;
			double z2;
			
		};
		
	};
} ;

#pragma option push -b-
enum MouseActMode { maNone, maRotate, maZoom, maRotAndZoom, maPan };
#pragma option pop

class DELPHICLASS TRot3D;
class PASCALIMPLEMENTATION TRot3D : public Controls::TGraphicControl 
{
	typedef Controls::TGraphicControl inherited;
	
private:
	int CubeCorners[8][3];
	double FViewAngle[3];
	Graphics::TBitmap* GrafBmp;
	MouseActMode FMouseAction;
	TDrawCan *RcFrstCan;
	TDrawCan *RcLastCan;
	Graphics::TColor RcDataCol;
	int FDataTag;
	Graphics::TColor RcFrameCol;
	Graphics::TColor RcChartCol;
	Graphics::TColor FColBlackLine;
	Graphics::TColor FColGrayLine;
	Graphics::TColor FColWhiteLine;
	TColorScheme FColorScheme;
	Graphics::TColor FColorCubeFrame;
	Graphics::TColor FColorCubeHidLin;
	Graphics::TColor FColorCubeFaceHi;
	Graphics::TColor FColorCubeFaceLo;
	TBoundingBox FBoundBox;
	int FBBSize;
	int FAxSize;
	bool FShowAxes;
	TFrameStyle FFrameStyle;
	bool FIsoMetric;
	bool FAutoOrigin;
	bool FAutoScale;
	double FOrigin[3];
	TAxName FAxName[3];
	int FMagnify;
	double FMagAnchor;
	int FMinCoord[3];
	int FMaxCoord[3];
	double FAngleAnchor[2];
	double FScaleFact[3];
	Graphics::TColor FItemColors[32];
	int FCentX;
	int FCentY;
	int FCentXAnchor;
	int FCentYAnchor;
	int RotMat[3][3];
	int NRotObj;
	void *FRotDataX;
	void *FRotDataY;
	void *FRotDataZ;
	void *FBackLink;
	void *FRotProp;
	void *FRotMark;
	Graphics::TFontStyles FTextFontStyle;
	Byte FTextMarkSize;
	int MouseAnchorX;
	int MouseAnchorY;
	void __fastcall ConstructDataBmp(Graphics::TCanvas* cv, bool BlkWhite);
	void __fastcall InitGraf(Graphics::TCanvas* cv, bool BlkWhite);
	void __fastcall ConstructFrame(Graphics::TCanvas* cv);
	void __fastcall SetDataCol(Graphics::TColor c);
	void __fastcall SetDataTag(int tag);
	void __fastcall SetFrameCol(Graphics::TColor c);
	void __fastcall SetChartCol(Graphics::TColor c);
	void __fastcall SetColCubeFrame(Graphics::TColor c);
	void __fastcall SetColCubeHidLin(Graphics::TColor c);
	void __fastcall SetColCubeFaceLow(Graphics::TColor c);
	void __fastcall SetColCubeFaceHigh(Graphics::TColor c);
	void __fastcall SetMagnify(double mag);
	TAxName __fastcall GetAxNameX();
	TAxName __fastcall GetAxNameY();
	TAxName __fastcall GetAxNameZ();
	double __fastcall GetMagnify(void);
	PDrawCan __fastcall GetFirstItemLL(void);
	ItemType __fastcall GetTypeOfFirstItem(void);
	ItemType __fastcall GetTypeOfLastItem(void);
	double __fastcall GetViewAngleX(void);
	double __fastcall GetViewAngleY(void);
	double __fastcall GetViewAngleZ(void);
	double __fastcall GetOriginX(void);
	double __fastcall GetOriginY(void);
	double __fastcall GetOriginZ(void);
	double __fastcall GetScaleFactX(void);
	double __fastcall GetScaleFactY(void);
	double __fastcall GetScaleFactZ(void);
	void __fastcall SetColorScheme(TColorScheme Value);
	void __fastcall SetCubeCorners(void);
	void __fastcall SetFrameStyle(TFrameStyle value);
	void __fastcall SetBoundBoxStyle(TBoundingBox value);
	void __fastcall SetBoundBoxSize(int value);
	int __fastcall GetBoundBoxSize(void);
	void __fastcall SetAxSize(int value);
	void __fastcall SetCentX(int value);
	void __fastcall SetCentY(int value);
	void __fastcall SetIsoMetric(bool value);
	void __fastcall SetAutoOrigin(bool value);
	void __fastcall SetAutoScale(bool value);
	void __fastcall SetShowAxes(bool value);
	void __fastcall SetTextFontStyle(Graphics::TFontStyles tfs);
	void __fastcall SetTextMarkSize(Byte tms);
	void __fastcall SetViewAngleX(double value);
	void __fastcall SetViewAngleY(double value);
	void __fastcall SetViewAngleZ(double value);
	void __fastcall SetOriginX(double value);
	void __fastcall SetOriginY(double value);
	void __fastcall SetOriginZ(double value);
	void __fastcall SetScaleFactX(double value);
	void __fastcall SetScaleFactY(double value);
	void __fastcall SetScaleFactZ(double value);
	void __fastcall SetAxNameX( TAxName &value);
	void __fastcall SetAxNameY( TAxName &value);
	void __fastcall SetAxNameZ( TAxName &value);
	
protected:
	DYNAMIC void __fastcall MouseMove(Classes::TShiftState Shift, int X, int Y);
	virtual void __fastcall CalcRotMatrix(void);
	virtual void __fastcall Paint(void);
	
public:
	__fastcall virtual TRot3D(Classes::TComponent* AOwner);
	__fastcall virtual ~TRot3D(void);
	void __fastcall Clear(void);
	__property Graphics::TColor ColorData = {read=RcDataCol, write=SetDataCol, default=0};
	void __fastcall CopyToBMP(AnsiString FName);
	void __fastcall CopyToWMF(AnsiString FName);
	void __fastcall CopyToClipboard(void);
	void __fastcall CopyToClipboardWMF(void);
	__property int DataTag = {read=FDataTag, write=SetDataTag, nodefault};
	void __fastcall MakeVisible(void);
	void __fastcall Drawto(double x, double y, double z);
	PDrawCan __fastcall FindNearestItemScreen(int mx, int my, ItemType ItemID, double &dist);
	PDrawCan __fastcall FindNearestItemReal(double mx, double my, double mz, ItemType ItemID, double &dist
		);
	TDrawCan __fastcall GetItemParams(PDrawCan Item);
	void __fastcall SetItemParams(PDrawCan Item, const TDrawCan &ItParams);
	void __fastcall Line(double x1, double y1, double z1, double x2, double y2, double z2);
	void __fastcall Moveto(double x, double y, double z);
	void __fastcall MarkAt(double x, double y, double z, Byte mk);
	void __fastcall Printit(double ScaleF, bool BlkWhite);
	void __fastcall RemoveLastItem(void);
	void __fastcall RemoveFirstItem(void);
	void __fastcall SetViewAngles(double vax, double vay, double vaz);
	void __fastcall SetOrigins(double vax, double vay, double vaz);
	void __fastcall SetScaleFactors(double sfx, double sfy, double sfz);
	__property PDrawCan FirstItemOfLinkedList = {read=GetFirstItemLL};
	__property ItemType TypeOfLastItem = {read=GetTypeOfLastItem, nodefault};
	__property ItemType TypeOfFirstItem = {read=GetTypeOfFirstItem, nodefault};
	__property double ScaleFactX = {read=GetScaleFactX, write=SetScaleFactX};
	__property double ScaleFactY = {read=GetScaleFactY, write=SetScaleFactY};
	__property double ScaleFactZ = {read=GetScaleFactZ, write=SetScaleFactZ};
	
__published:
	__property Font ;
	__property Align ;
	__property Visible ;
	__property ShowHint ;
	__property PopupMenu ;
	__property int CentX = {read=FCentX, write=SetCentX, nodefault};
	__property int CentY = {read=FCentY, write=SetCentY, nodefault};
	__property Graphics::TColor ColorFrame = {read=RcFrameCol, write=SetFrameCol, default=0};
	__property Graphics::TColor ColorChart = {read=RcChartCol, write=SetChartCol, default=16777215};
	__property TColorScheme ColorScheme = {read=FColorScheme, write=SetColorScheme, nodefault};
	__property Graphics::TColor ColorCubeFrame = {read=FColorCubeFrame, write=SetColCubeFrame, nodefault
		};
	__property Graphics::TColor ColorCubeHidLin = {read=FColorCubeHidLin, write=SetColCubeHidLin, nodefault
		};
	__property Graphics::TColor ColorCubeFaceLow = {read=FColorCubeFaceLo, write=SetColCubeFaceLow, nodefault
		};
	__property Graphics::TColor ColorCubeFaceHigh = {read=FColorCubeFaceHi, write=SetColCubeFaceHigh, nodefault
		};
	__property bool IsoMetric = {read=FIsoMetric, write=SetIsoMetric, nodefault};
	__property bool AutoOrigin = {read=FAutoOrigin, write=SetAutoOrigin, nodefault};
	__property bool AutoScale = {read=FAutoScale, write=SetAutoScale, nodefault};
	__property TFrameStyle FrameStyle = {read=FFrameStyle, write=SetFrameStyle, nodefault};
	__property double Magnification = {read=GetMagnify, write=SetMagnify};
	__property MouseActMode MouseAction = {read=FMouseAction, write=FMouseAction, nodefault};
	__property TBoundingBox BoundBoxStyle = {read=FBoundBox, write=SetBoundBoxStyle, nodefault};
	__property int BoundBoxSize = {read=GetBoundBoxSize, write=SetBoundBoxSize, nodefault};
	__property int AxSize = {read=FAxSize, write=SetAxSize, nodefault};
	__property TAxName AxNameX = {read=GetAxNameX, write=SetAxNameX};
	__property TAxName AxNameY = {read=GetAxNameY, write=SetAxNameY};
	__property TAxName AxNameZ = {read=GetAxNameZ, write=SetAxNameZ};
	__property bool ShowAxes = {read=FShowAxes, write=SetShowAxes, nodefault};
	__property Graphics::TFontStyles TextFontStyle = {read=FTextFontStyle, write=SetTextFontStyle, nodefault
		};
	__property Byte TextMarkSize = {read=FTextMarkSize, write=SetTextMarkSize, nodefault};
	__property double ViewAngleX = {read=GetViewAngleX, write=SetViewAngleX};
	__property double ViewAngleY = {read=GetViewAngleY, write=SetViewAngleY};
	__property double ViewAngleZ = {read=GetViewAngleZ, write=SetViewAngleZ};
	__property double OriginX = {read=GetOriginX, write=SetOriginX};
	__property double OriginY = {read=GetOriginY, write=SetOriginY};
	__property double OriginZ = {read=GetOriginZ, write=SetOriginZ};
	__property OnClick ;
	__property OnDblClick ;
	__property OnMouseMove ;
	__property OnMouseDown ;
	__property OnMouseUp ;
};


//-- var, const, procedure ---------------------------------------------------
static const int defDataCol = 0x0;
static const int defFrameCol = 0x0;
static const int defChartCol = 0xffffff;
static const Word defR3Height = 0x12c;
static const Word defR3Width = 0x1c2;
static const Shortint MaxItemColors = 0x1f;
static const Shortint MaxR3Marks = 0x19;
extern PACKAGE void __fastcall Register(void);

}	/* namespace Rot3d */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Rot3d;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Rot3D
